var Rec43000_ParametroContasReceber_Controller = function(ScreenService, General, templateManager, Rec43000_ParametroContasReceber_Service){
    
    var self = this;
    
    self.afterLoadSource = function(widget){
        var data = widget.dataSource.data[0];
        var dataEmpty = {
            'CDAJACREREC':'',
            'CDAJACRERENEGO':'',
            'CDAJDESCREC':'',
            'CDAJDESCRENEGO':'',
            'CDAJMORAREC':'',
            'CDAJMULTAREC':'',
            'CDAJTXCARTCNAB':'',
            'CDGERALREC':'',
            'CDGROPERCNTR':'',
            'CDMOTIPROR':'',
            'CDTPBXRENEGO':'',
            'DSAJACREREC':'',
            'DSAJACRERENEGO':'',
            'DSAJDESCREC':'',
            'DSAJDESCRENEGO':'',
            'DSAJMORAREC':'',
            'DSAJMULTAREC':'',
            'DSAJTXCARTCNAB':'',
            'DSMOTIPROR':'',
            'DSTPBXRENEGO':'',
            'IDBLOQALTBOLREC':'N',
            'IDBLOQINCNTR':'',
            'IDCOMPCHQBAIXA':'S',
            'IDEXTELACALAJUBX':'B',
            'IDTPCNTRLIB':'',
            'IDUTBCOPREFCLIE':'N',
            'IDUTCTRLCANREMR':'',
            'IDUTLNFDEVOLREC':'N',
            'IDUTLPRORVCREC':'',
            'NRORG':'',
            'QTDIAANTBAIR':'',
            'QTDIAANTBOLR':'',
            'QTDIAANTLANR':'',
            'QTDIAAPOBAIR':'',
            'QTDIAAPOBOLR':'',
            'QTDIAAPOLANR':'',
            'IDEXCLAJBBXR':'N',
            'IDUTENVBOLAUTO':'N',
            'QTDIAANTENVBOL':'',
            'IDUTENVCARTAUTO':'N',
            'QTDIAPOSENVCAR':'',
            'CDTPBAIRENVBOL':'',
            'IDUTVISUBOLOPEL':'N',
            'CDOPEPERVISUBOL':''
        };
        var dados = null;
        if (data) {
            dados = data;
            dados.__is_new = false;
            
            data.CDTPBAIRENVBOL_multi = data.CDTPBAIRENVBOL?data.CDTPBAIRENVBOL.split('_'):'';
            widget.getField('CDTPBAIRENVBOL_multi').reload();
            
            data.CDOPEPERVISUBOL_multi = data.CDOPEPERVISUBOL?data.CDOPEPERVISUBOL.split('_'):'';
            widget.getField('CDOPEPERVISUBOL_multi').reload();
            widget.redraw();
        }else{
            dados = dataEmpty;
            dados.__is_new = true;
        }
        
        widget.currentRow = dados;
        
        var intervaloDatasForm = templateManager.container.getWidget('intervaloDatasForm');
        intervaloDatasForm.currentRow.QTDIAANTLANR = dados.QTDIAANTLANR;
        intervaloDatasForm.currentRow.QTDIAAPOLANR = dados.QTDIAAPOLANR;
        intervaloDatasForm.currentRow.QTDIAANTBAIR = dados.QTDIAANTBAIR;
        intervaloDatasForm.currentRow.QTDIAAPOBAIR = dados.QTDIAAPOBAIR;
        intervaloDatasForm.currentRow.QTDIAANTBOLR = dados.QTDIAANTBOLR;
        intervaloDatasForm.currentRow.QTDIAAPOBOLR = dados.QTDIAAPOBOLR;
        
        templateManager.updateTemplate();
    };

    self.saveTabeds = function(){
        var widgetsTabed = templateManager.container.getWidget('tabbedParametrosContasReceber').widgets;
        var rowsToSave   = [];
        
        widgetsTabed[0].currentRow.CDTPBAIRENVBOL  = widgetsTabed[0].currentRow.CDTPBAIRENVBOL_multi?widgetsTabed[0].currentRow.CDTPBAIRENVBOL_multi.join('_'):'';
        widgetsTabed[0].currentRow.CDOPEPERVISUBOL = widgetsTabed[0].currentRow.CDOPEPERVISUBOL_multi?widgetsTabed[0].currentRow.CDOPEPERVISUBOL_multi.join('_'):'';

        for (var i = 0; i < widgetsTabed.length; i++) {
            var widget = widgetsTabed[i];
            rowsToSave.push(widget.currentRow);
        }
        
        Rec43000_ParametroContasReceber_Service.saveWidgets(rowsToSave, rowsToSave[0].__is_new).then(function () {
            widgetsTabed[0].view();
            widgetsTabed[0].template = widgetsTabed[0].templateToView;
            widgetsTabed[1].view();
            widgetsTabed[1].template = widgetsTabed[1].templateToView;
            widgetsTabed[0].reload();
            widgetsTabed[1].reload();
            widgetsTabed[0].currentRow.__is_new = false;
            self.afterLoadSource(widgetsTabed[0]);
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    self.editMode = function(){
        var widgetsTabed = templateManager.container.getWidget('tabbedParametrosContasReceber').widgets;
        for (var i = 0; i < widgetsTabed.length; i++) {
            var widget = widgetsTabed[i];
            General.edit(widget);
            widget.template = widget.templateToForm;
        }
    };

    self.backToView = function(){
        var widgetsTabed = templateManager.container.getWidget('tabbedParametrosContasReceber').widgets;
        for (var i = 0; i < widgetsTabed.length; i++) {
            var widget = widgetsTabed[i];
            widget.view();
            widget.currentRow = widget.backupRow;
            widget.template = widget.templateToView;
        }
    };
    
    this.HabilitaCampos = function(widget) { 
        
        var campoInclusaoConta =  widget.getField("IDBLOQINCNTR");
        var campoInclusaoContaOper = widget.getField("CDGROPERCNTR");
        var campoLiberaConta = widget.getField("IDTPCNTRLIB");
        var campoControlaProrrogacao = widget.getField("IDUTLPRORVCREC");
        var campoControlaProrrogacaoOper = widget.getField("CDGRUPOPER");
        var campoControlaProcessamento = widget.getField("IDUTLPROCREC");
        var campoControlaProcessamentoOper = widget.getField("CDGROPERPROR");
        var campoRecebimentoContrato = widget.getField("IDCONTROLARECCONTRATO");
        var campoRecebimentoContratoOper = widget.getField("CDGROPERRECCONTR");
        var campoCancelamentoRemessaBoleto = widget.getField("IDUTCTRLCANREMR");
        var campoCancelamentoRemessaBoletoOper = widget.getField("CDGRUPOPERCANREMR");
          
        if(campoInclusaoConta.value() == "S"){
            campoInclusaoContaOper.readOnly = false;
            campoLiberaConta.readOnly = false;
        } else{
            campoInclusaoContaOper.readOnly = true;
            campoInclusaoContaOper.setValue(""); 
            
            campoLiberaConta.readOnly = true;
            campoLiberaConta.setValue("");
        }
        
        if(campoControlaProrrogacao.value() == "S"){
          campoControlaProrrogacaoOper.readOnly = false;
        }else{
          campoControlaProrrogacaoOper.readOnly = true;
          campoControlaProrrogacaoOper.setValue("");
        }
        
        if(campoControlaProcessamento.value() == "S"){
          campoControlaProcessamentoOper.readOnly = false;
        }else{
          campoControlaProcessamentoOper.readOnly = true;
          campoControlaProcessamentoOper.setValue("");
        }
        
        if(campoRecebimentoContrato.value() == "S"){
          campoRecebimentoContratoOper.readOnly = false;
        }else{
         campoRecebimentoContratoOper.readOnly = true;
         campoRecebimentoContratoOper.setValue("");
        }
          
        if(campoCancelamentoRemessaBoleto.value() == "S"){
          campoCancelamentoRemessaBoletoOper.readOnly = false;
        }else{
          campoCancelamentoRemessaBoletoOper.readOnly = true;
          campoCancelamentoRemessaBoletoOper.setValue("");
        }
          
        campoInclusaoContaOper.reload();
        campoLiberaConta.reload();
        campoControlaProrrogacaoOper.reload();
        campoControlaProcessamentoOper.reload();
        campoRecebimentoContratoOper.reload();
        campoCancelamentoRemessaBoletoOper.reload();
    };
    
    this.saveTabedsOperadores = function(widget){
        
        var dataSet = { row:widget.currentRow};
        
        if(widget.isValid()){
            Rec43000_ParametroContasReceber_Service.saveTabedsOperadores(dataSet).then(
                function(sucess) {
                ScreenService.showMessage('Grupo de Operadores salvo com sucesso!');
            },
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }
            );
        }
    };
};
Configuration(function (ContextRegister){
    ContextRegister.register('Rec43000_ParametroContasReceber_Controller', Rec43000_ParametroContasReceber_Controller);
});